<?
/*****************************************************************************/
/* Aztek Forum - PHP/Mysql forum                                             */
/* Copyright (C) 2003, 2004 Le Guilcher Yannick                              */
/*                                                                           */
/* This file is part of Aztek Forum.                                         */
/*                                                                           */
/* Aztek Forum is free software; you can redistribute it and/or modify       */
/* it under the terms of the GNU General Public License as published by      */
/* the Free Software Foundation; either version 2 of the License, or         */
/* (at your option) any later version.                                       */
/*                                                                           */
/* Aztek Forum is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of            */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             */
/* GNU General Public License for more details.                              */
/*                                                                           */
/* You should have received a copy of the GNU General Public License         */
/* along with Aztek Forum; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
/*                                                                           */
/* Contact: webmaster@forum-aztek.com                                        */
/* Website: http://www.forum-aztek.com                                       */
/*****************************************************************************/

/***************************************************/
/* Rcupre les donnes  partir d'un fichier .xml */
/***************************************************/
function get_style($filename) {
	global $VERSION;

	$data = implode("",file($filename));
	$parser = xml_parser_create();
	xml_parser_set_option($parser,XML_OPTION_CASE_FOLDING,0);
	xml_parser_set_option($parser,XML_OPTION_SKIP_WHITE,1);
	xml_parse_into_struct($parser,$data,$values,$tags);
	xml_parser_free($parser);

	$flag=0;
	for ($i=0; $i < count($values); $i++) {

		// On rcupre le nom du style + vrification de la version compatible
		// Version compatible si mentionn et correspondant  la version du kit
		// Version compatible si version non mentionn dans le xml
		if($values[$i]["tag"]=="STYLE" && $values[$i]["type"]=="open"){
			if(!empty($values[$i]["attributes"]["version"]))
				$version = $values[$i]["attributes"]["version"];
			if(empty($version)) $flag++;
			if(!empty($version) && $version==$VERSION) $flag++;
			if(!empty($version) && $version=="all") $flag++;
		}

		// On rcupre les valeurs si autorisation OK
		if($flag==1 && $values[$i]["tag"]=="PARAM" && $values[$i]["type"]=="complete"){
			if(!empty($values[$i]["attributes"]["name"])){
				$name = $values[$i]["attributes"]["name"];
				if(!isset($values[$i]["value"])) $PARAM[$name] = "";
				else $PARAM[$name] = $values[$i]["value"];
			}
		}

		// On arrte l'autorisation de lire aprs la fermeture de la balise <STYLE>
		if($values[$i]["tag"]=="STYLE" && $values[$i]["type"]=="close" && $flag) $flag++;
	}

	if(!isset($PARAM)) $PARAM[]="";

	return $PARAM;
}

/********************************/
/* Cr un fichier de style xml */
/********************************/
function export_style($id, $stylename){
	global $VERSION, $LANG;

	// Paramtre non autoris dans le fichier xml
	$forbidden_key[0] = "id";
	$forbidden_key[1] = "passwd";
	$forbidden_key[2] = "owner";
	$forbidden_key[3] = "category";
	$forbidden_key[4] = "date";
	$forbidden_key[5] = "filename";
	$forbidden_key[6] = "nb_visit";
	$forbidden_key[7] = "nb_post";
	$forbidden_key[8] = "last_id";
	$forbidden_key[9] = "last_sender";
	$forbidden_key[10] = "last_date";
	$forbidden_key[11] = "order_cat";
	$forbidden_key[12] = "locked";
	$forbidden_key[13] = "hidden";
	$forbidden_key[14] = "mail_actived";
	$forbidden_key[15] = "return_mail";
	$forbidden_key[16] = "alert_mail";
	$forbidden_key[17] = "log_login";
	$forbidden_key[18] = "return_path";
	$forbidden_key[19] = "title";
	$forbidden_key[20] = "intro";
	$forbidden_key[21] = "subject";
	$forbidden_key[22] = "structure";

	
	// On rcupre les donnes du forum  expporter
	$query = "SELECT * FROM atk_forums WHERE id=$id";
	$PARAM = dbgetline($query, MYSQL_ASSOC);
	
	// Prpare le nom du fichier
	$filename = "./styles/" . $stylename . "/" . $stylename . ".xml";
	
	if(!file_exists($filename) && !file_exists("./styles/" . $stylename . "/")){
	
		mkdir("./styles/" . $stylename . "/");

		// Ouverture du fichier en criture
		$file = fopen($filename, "w");

		// Entte du fichier xml
		fwrite($file, "<?xml version=\"1.0\" encoding=\"ISO-8859-15\"?>\n\n");
		fwrite($file, "<ATK_STYLESHEET name=\"$stylename\">\n\n");
		fwrite($file, "\t<STYLE version=\"$VERSION\">\n\n");
		
		// Pour chaque attribut du forum
		foreach($PARAM as $key => $value) {
			$flag=0;
			for($i=0; $i<count($forbidden_key); $i++)
				if($key == $forbidden_key[$i]) $flag=1;
			if(!$flag){

				// Recherche les nom de fichier et supprime le chemin
				if(ereg("(.+)[\/](.+)$", $value, $result)) $filename = $result[2];
				else $filename = "";
				ereg("^(.+)\.(.+)$", $filename, $result);
				$ext = $result[2];
				if( ( (strlen($ext)<5 && strlen($ext)>0 && strlen($filename)>0) || @file_exists($value) ) && !is_dir($value) ){
					@copy($value, "./styles/" . $stylename . "/" . $filename);
					$value = "./styles/" . $stylename . "/" . $filename;
				}
				// Ecrit la valeur du paramtre dans le fichier
				$value = str_replace("\n","\\n",$value);
				$value = str_replace("\r","",$value);
				if($value=="") fwrite($file, "\t\t<PARAM name=\"$key\"/>\n");
				else fwrite($file, "\t\t<PARAM name=\"$key\">$value</PARAM>\n");

			}
		}
		
		// Fermeture des balises xml
		fwrite($file, "\n\t</STYLE>");
		fwrite($file, "\n\n</ATK_STYLESHEET>");
		
		// Fermeture du fichier
		fclose($file);
	
		return $LANG["EXPORT-STYLE-OK"];
	}

	return $LANG["EXPORT-STYLE-ERROR"];
}

/**********************************************************/
/* Fonction d'application d'un style prdfini  un forum */
/**********************************************************/
// On applique un style xml  un forum
function forum_xml($id, $dirname){
	// On rcupre les paramtres du fichier
	$PARAM = get_style("./styles/" . $dirname . "/" . $dirname . ".xml");
	// On applique ces paramtre au forum $id
	forum_apply($id, $PARAM);
}

// Copie d'un style d'un autre forum
function forum_copy($id_from, $id_to){

	// On rcupre les donnes du forum d'origine
	$query = "SELECT * FROM atk_forums WHERE id=$id_from";
	$PARAM = dbgetline($query, MYSQL_ASSOC);
	// On applique les paramtre au forum de destination
	forum_apply($id_to, $PARAM);
}

// Application d'un style sur un forum
function forum_apply($id_to, $PARAM){
	
	// On rcupre les donnes du forum d'origine
	$query = "SELECT * FROM atk_forums WHERE id=$id_to";
	$SELF = dbgetline($query, MYSQL_ASSOC);
	extract($SELF, EXTR_OVERWRITE);
	
	// On supprime les doubles quotes
	foreach($PARAM AS $key=>$value)
		$PARAM[$key] = str_replace("\"","'", $PARAM[$key]);
	
	// On extrait les valeurs envoyes par l'url
	extract($PARAM, EXTR_OVERWRITE);
	
	// On enregistre les nouvelles valeurs
	$query="
		UPDATE atk_forums SET

		bg_img=\"$bg_img\", img_fixed=\"$img_fixed\",
		bg_img_tab = \"$bg_img_tab\",bg_img_tab_new = \"$bg_img_tab_new\",  bg_img_tab_title = \"$bg_img_tab_title\", img_new= \"$img_new\",
		img_line_1 = \"$img_line_1\", img_line_2 = \"$img_line_2\", img_post_it = \"$img_post_it\", img_ssmenu=\"$img_ssmenu\",
		img_col=\"$img_col\",folder = \"$folder\", folder_new = \"$folder_new\",
		folder_fire = \"$folder_fire\", folder_new_fire = \"$folder_new_fire\",
		puce_post_it = \"$puce_post_it\", puce_post_it_new = \"$puce_post_it_new\",
		folder_poll = \"$folder_poll\", folder_poll_new = \"$folder_poll_new\",
		poll_left_bar = \"$poll_left_bar\", poll_middle_bar=\"$poll_middle_bar\", poll_right_bar=\"$poll_right_bar\",
		button=\"$button\",

		bg_color=\"$bg_color\", border_color=\"$border_color\", border_width = \"$border_width\",
		bg_title_color=\"$bg_title_color\", bg_body_color=\"$bg_body_color\", bg_body_color_new=\"$bg_body_color_new\",
		table_bg_color=\"$table_bg_color\", table_border_color=\"$table_border_color\",
		del_mess_bg_color=\"$del_mess_bg_color\",
		bg_line_1=\"$bg_line_1\", bg_line_2=\"$bg_line_2\", bg_post_it=\"$bg_post_it\", bg_ssmenu=\"$bg_ssmenu\", bg_col=\"$bg_col\",
		bg_highlight = \"$bg_highlight\", bg_onclick = \"$bg_onclick\", separation=\"$separation\",
		title_color=\"$title_color\", intro_color=\"$intro_color\",
		selected_color=\"$selected_color\",
		menu_color=\"$menu_color\", menu_color_a=\"$menu_color_a\",
		link_color=\"$link_color\", link_color_a=\"$link_color_a\",
		post_color_tab=\"$post_color_tab\", post_color_a_tab=\"$post_color_a_tab\", post_color_v_tab=\"$post_color_v_tab\",
		post_color_arbo=\"$post_color_arbo\", post_color_a_arbo=\"$post_color_a_arbo\", post_color_v_arbo=\"$post_color_v_arbo\",
		post_it_color=\"$post_it_color\", post_it_color_a=\"$post_it_color_a\", ssmenu_color=\"$ssmenu_color\",
		text_color=\"$text_color\", button_link_color=\"$button_link_color\", button_link_color_a=\"$button_link_color_a\",
		input_bg_color=\"$input_bg_color\", input_text_color=\"$input_text_color\", input_border_color=\"$input_border_color\",
		scrollbar_base_color=\"$scrollbar_base_color\", scrollbar_face_color=\"$scrollbar_face_color\",
		scrollbar_highlight_color=\"$scrollbar_highlight_color\", scrollbar_shadow_color=\"$scrollbar_shadow_color\",
		scrollbar_3dlight_color=\"$scrollbar_3dlight_color\", scrollbar_arrow_color=\"$scrollbar_arrow_color\",
		scrollbar_track_color=\"$scrollbar_track_color\", scrollbar_darkshadow_color=\"$scrollbar_darkshadow_color\",

		font_title=\"$font_title\", size_title=\"$size_title\", style_title=\"$style_title\",
		font_intro=\"$font_intro\", size_intro=\"$size_intro\", style_intro=\"$style_intro\",
		font_text=\"$font_text\", size_text=\"$size_text\", style_text=\"$style_text\",
		font_menu=\"$font_menu\", size_menu=\"$size_menu\", style_menu=\"$style_menu\",
		font_menu_a=\"$font_menu_a\", size_menu_a=\"$size_menu_a\", style_menu_a=\"$style_menu_a\",
		font_post=\"$font_post\", size_post=\"$size_post\", style_post=\"$style_post\",
		font_post_a=\"$font_post_a\", size_post_a=\"$size_post_a\", style_post_a=\"$style_post_a\",
		font_ssmenu=\"$font_ssmenu\", size_ssmenu=\"$size_ssmenu\", style_ssmenu=\"$style_ssmenu\",
		font_link=\"$font_link\", size_link=\"$size_link\", style_link=\"$style_link\",
		font_link_a=\"$font_link_a\", size_link_a=\"$size_link_a\", style_link_a=\"$style_link_a\",
		font_button_link=\"$font_button_link\", size_button_link=\"$size_button_link\", style_button_link=\"$style_button_link\",
		font_button_link_a=\"$font_button_link_a\", size_button_link_a=\"$size_button_link_a\", style_button_link_a=\"$style_button_link_a\",

		url_title=\"$url_title\",
		nb_subjects_per_page=\"$nb_subjects_per_page\", nb_posts_per_page=\"$nb_posts_per_page\",
		nb_members_per_page=\"$nb_members_per_page\", nb_folder_fire=\"$nb_folder_fire\",

		top_url=\"$top_url\", bottom_url=\"$bottom_url\",
		return_index=\"$return_index\", language=\"$language\", log=\"$log\", log_forum=\"$log_forum\", width=\"$width\",
		local_time=\"$local_time\", fade_link=\"$fade_link\", fade_icon=\"$fade_icon\",
		icon=\"$icon\", tags=\"$tags\", dblmenu=\"$dblmenu\",  edit=\"$edit\", edit_alert=\"$edit_alert\",
		html=\"$html\", avatar=\"$avatar\", incrementation=\"$incrementation\", up_subject=\"$up_subject\",
		arbo=\"$arbo\", nb_smiley=\"$nb_smiley\", global_smiley=\"$global_smiley\", smiley_path=\"$smiley_path\",
		comment=\"$comment\", show_stat = \"$show_stat\", show_connected = \"$show_connected\",
		other_profile=\"$other_profile\", fast_view=\"$fast_view\",status=\"$status\",max_status=\"$max_status\",
		show_ssmenu = \"$show_ssmenu\", upload = \"$upload\", poll=\"$poll\", dynamic_poll=\"$dynamic_poll\",
		free_login=\"$free_login\",infos_perso=\"$infos_perso\",
		
		meta_title=\"$meta_title\", meta_keywords=\"$meta_keywords\", meta_description=\"$meta_description\"

		WHERE id=$id_to";
		
	dbquery($query);

}

/*********************************************************/
/* Fonction d'application d'un style prdfini  un index*/
/*********************************************************/
// On applique un style xml  un index
function index_xml($owner, $dirname){
	// On rcupre les paramtres du fichier
	$PARAM = get_style("./styles/" . $dirname . "/" . $dirname . ".xml");
	// On applique ces paramtre au forum $id
	index_apply($owner, $PARAM);
}

// Copie d'un style d'un forum vers un index
function index_copy_forum($owner, $id_from){
	// On rcupre les donnes du forum d'origine
	$query = "SELECT * FROM atk_forums WHERE id=$id_from";
	$PARAM = dbgetline($query, MYSQL_ASSOC);
	// On applique les paramtre au forum de destination
	index_apply($owner, $PARAM);
}

// Copie d'un style d'un index vers un autre index
function index_copy_index($owner_to, $owner_from){
	// On rcupre les donnes du forum d'origine
	$query = "SELECT * FROM atk_index WHERE owner='$owner_from'";
	$PARAM = dbgetline($query, MYSQL_ASSOC);
	// On applique les paramtre au forum de destination
	index_apply($owner_to, $PARAM);
}

// Application d'un style sur un index
function index_apply($owner_to, $PARAM){

	// On rcupre les donnes du forum d'origine
	$query = "SELECT * FROM atk_index WHERE owner='$owner_to'";
	$SELF = dbgetline($query, MYSQL_ASSOC);
	extract($SELF, EXTR_OVERWRITE);
	
	// On supprime les doubles quotes
	foreach($PARAM AS $key=>$value)
		$PARAM[$key] = str_replace("\"","'", $PARAM[$key]);

	// On extrait les valeurs envoyes par l'url
	extract($PARAM, EXTR_OVERWRITE);

	// On enregistre les nouvelles valeurs
	$query = "
		UPDATE atk_index SET

		bg_img=\"$bg_img\", img_fixed=\"$img_fixed\",
		bg_img_tab = \"$bg_img_tab\", bg_img_tab_title = \"$bg_img_tab_title\",
		img_line_1 = \"$img_line_1\", img_line_2 = \"$img_line_2\", img_ssmenu=\"$img_ssmenu\",
		img_col=\"$img_col\",folder = \"$folder\", folder_new = \"$folder_new\",
		folder_fire = \"$folder_fire\", folder_new_fire = \"$folder_new_fire\", button=\"$button\",

		bg_color=\"$bg_color\", border_color=\"$border_color\", border_width = \"$border_width\",
		bg_title_color=\"$bg_title_color\", bg_body_color=\"$bg_body_color\",
		table_bg_color=\"$table_bg_color\", table_border_color=\"$table_border_color\",
		del_mess_bg_color=\"$del_mess_bg_color\",
		bg_line_1=\"$bg_line_1\", bg_line_2=\"$bg_line_2\", separation=\"$separation\", bg_ssmenu=\"$bg_ssmenu\", bg_col=\"$bg_col\",
		bg_highlight = \"$bg_highlight\", bg_onclick = \"$bg_onclick\", title_color=\"$title_color\", intro_color=\"$intro_color\",
		selected_color=\"$selected_color\",
		menu_color=\"$menu_color\", menu_color_a=\"$menu_color_a\",
		link_color=\"$link_color\", link_color_a=\"$link_color_a\",
		post_color_tab=\"$post_color_tab\", post_color_a_tab=\"$post_color_a_tab\", post_color_v_tab=\"$post_color_v_tab\",
		text_color=\"$text_color\", ssmenu_color=\"$ssmenu_color\", button_link_color = \"$button_link_color\", button_link_color_a = \"$button_link_color_a\",
		input_bg_color=\"$input_bg_color\", input_text_color=\"$input_text_color\", input_border_color=\"$input_border_color\",
		scrollbar_base_color=\"$scrollbar_base_color\", scrollbar_face_color=\"$scrollbar_face_color\",
		scrollbar_highlight_color=\"$scrollbar_highlight_color\", scrollbar_shadow_color=\"$scrollbar_shadow_color\",
		scrollbar_3dlight_color=\"$scrollbar_3dlight_color\", scrollbar_arrow_color=\"$scrollbar_arrow_color\",
		scrollbar_track_color=\"$scrollbar_track_color\", scrollbar_darkshadow_color=\"$scrollbar_darkshadow_color\",

		font_title=\"$font_title\", size_title=\"$size_title\", style_title=\"$style_title\",
		font_intro=\"$font_intro\", size_intro=\"$size_intro\", style_intro=\"$style_intro\",
		font_text=\"$font_text\", size_text=\"$size_text\", style_text=\"$style_text\",
		font_menu=\"$font_menu\", size_menu=\"$size_menu\", style_menu=\"$style_menu\",
		font_menu_a=\"$font_menu_a\", size_menu_a=\"$size_menu_a\", style_menu_a=\"$style_menu_a\",
		font_post=\"$font_post\", size_post=\"$size_post\", style_post=\"$style_post\",
		font_post_a=\"$font_post_a\", size_post_a=\"$size_post_a\", style_post_a=\"$style_post_a\",
		font_ssmenu=\"$font_ssmenu\", size_ssmenu=\"$size_ssmenu\", style_ssmenu=\"$style_ssmenu\",
		font_link=\"$font_link\", size_link=\"$size_link\", style_link=\"$style_link\",
		font_link_a=\"$font_link_a\", size_link_a=\"$size_link_a\", style_link_a=\"$style_link_a\",
		font_button_link=\"$font_button_link\", size_button_link=\"$size_button_link\", style_button_link=\"$style_button_link\",
		font_button_link_a=\"$font_button_link_a\", size_button_link_a=\"$size_button_link_a\", style_button_link_a=\"$style_button_link_a\",

		url_title=\"$url_title\",
		nb_members_per_page=\"$nb_members_per_page\", nb_subjects_per_page = \"$nb_subjects_per_page\", nb_folder_fire=\"$nb_folder_fire\",

		top_url=\"$top_url\", bottom_url=\"$bottom_url\",
		language=\"$language\", width=\"$width\",
		local_time=\"$local_time\", fade_link=\"$fade_link\", fade_icon=\"$fade_icon\",
		icon=\"$icon\", tags=\"$tags\", dblmenu=\"$dblmenu\", html=\"$html\",
		avatar=\"$avatar\", nb_smiley=\"$nb_smiley\", global_smiley=\"$global_smiley\", smiley_path=\"$smiley_path\",
		other_profile=\"$other_profile\", fast_view=\"$fast_view\", show_stat = \"$show_stat\",show_connected=\"$show_connected\",
		status=\"$status\",max_status=\"$max_status\", upload = \"$upload\", infos_perso=\"$infos_perso\",infos_perso=\"$infos_perso\",
		
		meta_title=\"$meta_title\", meta_keywords=\"$meta_keywords\", meta_description=\"$meta_description\"

		WHERE owner=\"$owner_to\"";

	dbquery($query);

}
?>
