<?
/*****************************************************************************/
/* Aztek Forum - PHP/Mysql forum                                             */
/* Copyright (C) 2003, 2004 Le Guilcher Yannick                              */
/*                                                                           */
/* This file is part of Aztek Forum.                                         */
/*                                                                           */
/* Aztek Forum is free software; you can redistribute it and/or modify       */
/* it under the terms of the GNU General Public License as published by      */
/* the Free Software Foundation; either version 2 of the License, or         */
/* (at your option) any later version.                                       */
/*                                                                           */
/* Aztek Forum is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of            */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             */
/* GNU General Public License for more details.                              */
/*                                                                           */
/* You should have received a copy of the GNU General Public License         */
/* along with Aztek Forum; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
/*                                                                           */
/* Contact: webmaster@forum-aztek.com                                        */
/* Website: http://www.forum-aztek.com                                       */
/*****************************************************************************/

/*******************************************************/
/* Identifie un type d'erreur grace  un code d'erreur */
/*******************************************************/
function error($err=0){
	global $ATK_LOGIN;

	$debug = debug_backtrace();

	$file = $debug[0]["file"];
     $function = $debug[1]["function"];
     $line = $debug[0]["line"];
	$type = "Security";

	switch($err){
		// Erreur des fichiers communs
		case 1:	$more = "Can't connect to Database"; break;	

		// Erreur de la gestion administrateur
		case 10:	$more = "Illegal try to create new forum by " . $ATK_LOGIN; break;
		case 11:	$more = "Illegal try to delete forum by " . $ATK_LOGIN; break;
		case 12:	$more = "Illegal try to change user password by " . $ATK_LOGIN; break;
		case 13:	$more = "Illegal try to delete user(s) by " . $ATK_LOGIN; break;
		case 14:	$more = "Illegal try to delete admin privileges by " . $ATK_LOGIN; break;
		case 15:	$more = "Illegal try to create admin privileges by " . $ATK_LOGIN; break;
		case 16:	$more = "Illegal try to modify forum by " . $ATK_LOGIN; break;
		case 17:	$more = "Illegal try to modify index by " . $ATK_LOGIN; break;
		case 18:	$more = "Illegal try to uninstall Aztek by " . $ATK_LOGIN; break;
		case 19:	$more = "Illegal action on posts by " . $ATK_LOGIN; break;
		case 20:	$more = "Illegal try to delete account by " . $ATK_LOGIN; break;
		case 21:	$more = "Illegal try to lock forum by " . $ATK_LOGIN; break;
		case 22:	$more = "Illegal try to hide forum by " . $ATK_LOGIN; break;
		case 23:	$more = "Illegal try to modify profile user(s) by " . $ATK_LOGIN; break;
		case 24:	$more = "Illegal try to modify ban/unban user(s) by " . $ATK_LOGIN; break;

		// Erreur de la partie forum
		case 41: 	$more = "Illegal try to edit posts by " . $ATK_LOGIN; break;
		case 42: 	$more = "Illegal try to move posts by " . $ATK_LOGIN; break;
		case 43:	$more = "Illegal try to move category by " . $ATK_LOGIN; break;
		case 44:	$more = "Illegal try to move forum by " . $ATK_LOGIN; break;

		// Erreur indfini
		default:	$more = "Undefined error";
	}

	// Affiche l'erreur et l'enregistre
	print_error($type, $file, $function, $line, $more);

}

/***********************************/
/* Affichage d'un message d'erreur */
/***********************************/
function print_error($type, $file, $function, $line, $more){

	$location = $type . " error in file " . $file . " in function " . $function . " at line " . $line;
	
	// Affiche l'alerte de l'erreur en html
	echo "<BR><BR>";
	echo "<TABLE style=\"border-width: 3px; border-style: solid;\" bordercolor=#FF0000 bgcolor='#FFDDDD' cellpadding=10>";
	echo "<TR><TD>";
		echo "<b><font color=red>";
		echo $location;
		echo "</font></b>";
		if($more){
			echo "<BR><BR>";
			echo $more;
		}
		echo "<BR><BR>";
		echo "<i>Please note this error and contact your administrator.</i>";
	echo "</TD></TR>";
	echo "</TABLE>";
	echo "<BR><BR>";
	
	// Enregistre l'erreur dans un fichier
	reccord_error($location, $more);
	
	// Arrte l'excution du script
	exit;
}

/********************************************************/
/* Enregistrement des erreurs dans le fichier error.txt */
/********************************************************/
function reccord_error($location, $more){

	$DATE = time();
	$date = date("d-m-Y H:i:s", $DATE);

	$text = ">> " . $date . "\n" . $location;
	if($more) $text .= "\n" . $more;
	$text .= "\n\n";

	$file = fopen("./common/error.txt", "a+");
	fwrite($file,$text);
	fclose($file);
}
?>
