<?
/*****************************************************************************/
/* Aztek Forum - PHP/Mysql forum                                             */
/* Copyright (C) 2003, 2004 Le Guilcher Yannick                              */
/*                                                                           */
/* This file is part of Aztek Forum.                                         */
/*                                                                           */
/* Aztek Forum is free software; you can redistribute it and/or modify       */
/* it under the terms of the GNU General Public License as published by      */
/* the Free Software Foundation; either version 2 of the License, or         */
/* (at your option) any later version.                                       */
/*                                                                           */
/* Aztek Forum is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of            */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             */
/* GNU General Public License for more details.                              */
/*                                                                           */
/* You should have received a copy of the GNU General Public License         */
/* along with Aztek Forum; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
/*                                                                           */
/* Contact: webmaster@forum-aztek.com                                        */
/* Website: http://www.forum-aztek.com                                       */
/*****************************************************************************/

/********************************************/
/* Gestion de scurit des variables entrantes */
/********************************************/
include("./common/safety.php");

/***************************************/
/* Initialise les donnes et fonctions */
/***************************************/
include("./index/init.php");

/************************************/
/* Excute une action si ncessaire */
/************************************/
switch($action){

	// Affiche la prvisualisation
	case "prev":
			include("./index/prev.php");
			exit; break;

	// Mot de passe oubli
	case "new_passwd":
			$message=random_passwd($login);
			break;

	// Changement de mot de passe
	case "passwd":
			$message=modify_passwd($new_passwd_1,$new_passwd_2,$old_passwd);
			break;

	// On se logue
	case "login":
			if(empty($login)) $login="";
			if(empty($cookie)) $cookie="";
			$message=login($login, $passwd, $cookie);
			break;

	// Modifie le profil
	case "profile":
			if(!isset($show_email)) $show_email=0;
			if(!isset($alert_mp)) $alert_mp=0;
			if(!isset($other)) $other="";
			if(!isset($fast_view)) $fast_view=0;
			if(!isset($smiley)) $smiley=0;
			if(!isset($avatar)) $avatar="";
			$message=profile($email, $show_email, $alert_mp, $avatar, $town, $text, $url, $smiley, $msn, $aim, $yahoo, $icq, $other, $fast_view);
			break;

	// Dconnexion du membre
	case "disconnect":
			$message=disconnect();
			break;

	// Nouvelle inscription
	case "subscribe":
			if(empty($cookie)) $cookie="";
			if(empty($show_email)) $show_email="";
			$message=subscribe($owner,$login,$passwd,$passwd2,$email,$show_email,$cookie);
			break;

     // Envoie un message sur une messagerie
	case "inbox_send":
			$message=inbox_send($recipient,$title,$text);
			break;

	// Vide les message supprim de la corbeille
	case "inbox_purge":
			$message=inbox_purge();
			break;

	// Change le sttut d'un message de la messgerie
	case "inbox_del":
			if(empty($select)) $select=0;
			inbox_del($select);
			break;

	// Dplace les rubriques		
	case "move_cat":
			move_cat($id_cat, $dir);
			break;

	// Dplace les forums dans les rubriques		
	case "move_forum":
			move_forum($id_forum, $dir);
			break;
			
}

/********************************/
/* Calcul les membres connects */
/********************************/
if(!empty($PF["show_connected"])){

	$expire=$SESSION_EXPIRE-$USER_CONNEXION_TIME;
	
	// Session php
	if($PHP_SESS_ENABLED){
	
		// Recherche des connects non invits
		$query = "
			SELECT atk_sessions.user, atk_sessions.session, atk_sessions.forum
			FROM atk_forums, atk_sessions
			WHERE atk_sessions.expire >= $expire
			AND atk_sessions.user <> 'nobody'
			AND atk_sessions.forum = atk_forums.id
			AND atk_forums.owner = '$owner'
			GROUP BY atk_sessions.session";
		$sql = dbquery($query);
		
		// Recherche les connects
		$ii = 0; $if = 0;
		while($row=mysql_fetch_array($sql)){
			$SESS_USE[$row["session"]] = 1;
			$CONNECTED_INDEX[$ii++]=$row["user"];
			$CONNECTED_INDEX_USER[$row["user"]]=1;
		}
	
	// Session fait "maison"	
	} else {

		$query = "
			SELECT atk_sessions.user, atk_users.email,
			atk_users.show_email, atk_sessions.ip, atk_sessions.forum
			FROM atk_forums, atk_sessions
			LEFT OUTER JOIN atk_users
			ON atk_sessions.user=atk_users.login
			WHERE atk_sessions.expire >= $expire
			AND atk_sessions.forum = atk_forums.id
			AND atk_forums.owner = '$owner'";
		$sql = dbquery($query);
		
		// Recherche les connects
		$ii = 0; $NOBODY_INDEX = 0;
		$if = 0; $NOBODY_FORUM = 0;
		while($row=mysql_fetch_array($sql)){
			
			// Enlve le dernier nombre de l'ip pour les no_ip qui changent toujours d'ip...
			ereg ("([0-9]{1,3}).([0-9]{1,3}).([0-9]{1,3}).([0-9]{1,3})", $row["ip"], $regs);
   			$row["ip"] = $regs[1] . "." . $regs[2] . "." . $regs[3];
			
			if($row["user"]=="nobody" && empty($IP_index[$row["ip"]])){
				$IP_index[$row["ip"]]=1;
				$NOBODY_INDEX++;
			}
			if($row["user"]!="nobody" && empty($CONNECTED_INDEX_USER[$row["user"]])){
				$CONNECTED_INDEX[$ii++]=$row["user"];
				$CONNECTED_INDEX_USER[$row["user"]]=1;
			}
		}
	}
}

/**********************************/
/* Ne mets pas les pages en cache */
/**********************************/
no_cache();

/************************/
/* Dbut Affichage HTML */
/************************/
echo "<HTML><HEAD>";
// Va chercher les metatags
meta_tags();
// Rcupre la feuille de style
echo "<STYLE>";
include("./index/style.css");
echo "</STYLE>";
echo "</HEAD>";
echo "<BODY class=atk_body>";

/*******************************/
/* Options de personnalisation */
/*******************************/
// Mise en place du Fade
if($PF["fade_link"] OR $PF["fade_icon"]) include("./javascript/Fade.js");
// Inclusion du fichier d'entete
if($PF["top_url"]) @include($PF["top_url"]);

/***********************/
/* Affichage principal */
/***********************/
// Affichage du tableau principal qui contient tout
echo "<table border=0 width=" . $PF["width"] . " align=center><tr><td>";

	// Affichage du titre
	// Affichage du titre
	if($PF["url_title"]) echo "<p class=atk_title><IMG src='" . $PF["url_title"] . "' border=0></p>";
	if(!$PF["top_url"] && !$PF["url_title"]) echo "<p class=atk_title>" . $PF["title"] . "</p>";
	
	// Affichage du texte d'intro
	if(!$PF["top_url"] && $PF["intro"]) echo "<p class=atk_intro>" . $PF["intro"] . "<BR><BR>";
	
	/*********************/
	/* Affichage du menu */
	/*********************/
	navigator($choix);
	
	/***************************/
	/* Message d'avertissement */
	/***************************/
	if($message!="") alert($message);
	
	/***********************************************/
	/* Affichage en fonction de la variable $choix */
	/***********************************************/
	switch($choix){

		// Affichage de l'index
		case 0:	
			view_index($owner);
			if(!empty($PF["show_stat"])) infos();
			break;

		// Affichage du formulaire de connexion
		case 1:	
			show_connexion();
			break;

		// Affichage du formulaire d'inscription
		case 2:	
			if(empty($email)) $email="";
			show_subscribe($login,$email);
			break;

		// Formulaire pour modifier le profil
		case 3:
			modify_profile();
			break;

		// Affichage des membres
		case 5:
			if($page==0) $page=1;
			if(!isset($method)) $method=0;
			show_members($owner, $page, $method, $login);
			break;

		// Affichage du formulaire modifier password
		case 8:
			dbclose();
			if($DROIT>0) change_password();
			break;

		// Affichage du formulaire de recherche
		case 10:
			if(!isset($search)) $search="";
			if(!isset($forum_choice)) $forum_choice=0;
			search($search, $forum_choice, $owner, $page);
			break;

		// Affichage de la messagerie
		case 11:
			if(!isset($read)) $read=0;
			if(!isset($option)) $option=1;
			if(!isset($recipient)) $recipient="";
			$title=StripSlashes($title);
			$text=StripSlashes($text);
			inbox($read, $option, $recipient, $title, $text);
			break;

		// Affichage de la messagerie
		case 12:
			new_post($owner);
			break;			
			
		// Affichage des infos sur les connects et le forum
		case 13:
			include_once("index/infos.php");
			infos();
			help();
			break;
			
		// Affiche les posts d'un membre
		case 15:
			include_once("index/member_posts.php");
			if($page==0) $page=1;
			if(!isset($member)) $member=$owner;
			member_posts($member, $page);
			break;
	}

	/************************************/
	/* Fermeture de la bdd si non ferm */
	/************************************/
	dbclose();
	
	/************************************/
	/* Affiche les infos de bas de page */
	/************************************/
	// Affichage de la phrase Aztek
	echo "<p class=atk_aztek>" . $LANG["GET-YOUR-FORUM"];
	echo " - <a class=atk_aztek href='./myadmin.php' target='_blank'>" . $LANG["ADMINISTRATION"] . "</A>";
	echo " - <a class=atk_aztek href='./mystats.php' target='_blank'>" . $LANG["MyStats"] . "</A>";
	echo "<br>Aztek Forum V" . $VERSION . " ";
	echo "<a class=atk_aztek href='./COPYING.txt' target='_blank'>" . $LANG["COPYRIGHT"] . "</a> - <a class=atk_aztek href='./links.php' target='_blank'>" . $LANG["LINKS"] . "</a> - ";
	// Calcul du temps de gnration
	$tps_end = get_microtime();
	$tps = $tps_end - $tps_start;
	$LANG["GENERATE"] = str_replace("%sec",trim(number_format($tps,4,".","")),$LANG["GENERATE"]);
	if(!isset($DBCOUNT)) $DBCOUNT=0;
	echo str_replace("%dbcount",$DBCOUNT,$LANG["GENERATE"]);

// Fin du tableau global
echo "</td></tr></table>";

/****************************************/
/* Affichage du fichier de pied de page */
/****************************************/
if($PF["bottom_url"]) @include($PF["bottom_url"]);

/***********************/
/* Fin de la page HTML */
/***********************/
echo "</BODY>";
echo "</HTML>";
?>
