<?
/*****************************************************************************/
/* Aztek Forum - PHP/Mysql forum                                             */
/* Copyright (C) 2003, 2004 Le Guilcher Yannick                              */
/*                                                                           */
/* This file is part of Aztek Forum.                                         */
/*                                                                           */
/* Aztek Forum is free software; you can redistribute it and/or modify       */
/* it under the terms of the GNU General Public License as published by      */
/* the Free Software Foundation; either version 2 of the License, or         */
/* (at your option) any later version.                                       */
/*                                                                           */
/* Aztek Forum is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of            */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             */
/* GNU General Public License for more details.                              */
/*                                                                           */
/* You should have received a copy of the GNU General Public License         */
/* along with Aztek Forum; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
/*                                                                           */
/* Contact: webmaster@forum-aztek.com                                        */
/* Website: http://www.forum-aztek.com                                       */
/*****************************************************************************/

/***

    Ce fichier permet de d'inscrire un user dans
    la base de donnes du forum.

    Le fichier s'excute par un include simplement avec pour paramtre
    $atk_login et le $atk_passwd correspondant. $atk_email est optionnel

    Exemple d'utilisation :

    $atk_login = $login;
    $atk_passwd = $password;
    $atk_email = $email;
    $success = include("Aztek/tools/subscribe.php");
    if($success){
        // Ici raliser l'inscription dans la base des utilisateurs du reste du site
        echo "Inscription russie";
    } else {
        echo "Inscription non accepte";
    }

    Remarques :
    * Pour des raison de scurit, ce programme doit se trouver dans
    un rpertoire protg par .htaccess
    * Il faut d'abord envoy l'action sur le forum, vrifier si l'action est
    accept, et si oui, la ralis pour le reste du site. Le forum est prioritaire
    * Pensez  vrifier le password et sa vrification avant l'inscription sur
    le forum (Ce script ne vrifie pas le password et une ventuelle vrification
    par double champ)
    * N'oubliez pas de renseigner les paramtre juste ci-dessous, ou les 5 premiers
    paramtres sont les mme que dans le fichier common/bddconf.php et ou $OWNER
    est le login propritaire des forums sur lesquels vous inscrivez (le superadministrateur
    des forums le plus souvent)
    
    Parmis les donnes  configurer, $OWNER est le nom de l'administrateur qui a cr le forum
    sur lequel le membre s'inscrit

***/

/*********************************************************/
/* Donnes  configurer pour faire fonctionner ce script */
/*********************************************************/
if(file_exists("./common/bddconf.php")){
	include_once("./common/bddconf.php");
	$ATK_DBHOST = $DBHOST;
	$ATK_USEBDD = $USEBDD;
	$ATK_USER = $USER;
	$ATK_PASSWORD = $PASSWORD;
	$ATK_SALT = $SALT;
} else {
	$ATK_DBHOST = "localhost";
	$ATK_USEBDD = "";
	$ATK_USER = "";
	$ATK_PASSWORD = "";
	$ATK_SALT = "";
}
$OWNER = "";

/**********************************/
/* Connexion  la base de donnes */
/**********************************/
function atk_dbconnect(){
	global $ATK_DBHOST, $ATK_USEBDD, $ATK_USER, $ATK_PASSWORD, $ATK_HANDLE;

	$ATK_HANDLE=mysql_connect($ATK_DBHOST,$ATK_USER,$ATK_PASSWORD);
	$database=mysql_select_db($ATK_USEBDD,$ATK_HANDLE);

	return($ATK_HANDLE);
}

/*********************************************/
/* Ferme la connexion  la bdd si ncessaire */
/*********************************************/
function atk_dbclose(){
	global $ATK_HANDLE;

	if($ATK_HANDLE){
		mysql_close($ATK_HANDLE);
		$ATK_HANDLE=0;
	}
}

/***********************/
/* Excute une requete */
/***********************/
function atk_dbquery($query){
	global $ATK_HANDLE;

	$sql=mysql_query($query,$ATK_HANDLE);

	return $sql;
}

/************************************************/
/* Rcupre le 1er enregistrement d'une requete */
/************************************************/
function atk_dbgetfirst($query){
	global $ATK_HANDLE;

	$sql=mysql_query($query,$ATK_HANDLE);
	if($row=mysql_fetch_row($sql)) $result=$row[0];
	else $result=0;

	return $result;
}

/**********************************/
/* Vrifie si un user existe dj */
/**********************************/
function atk_user_exist($login){
	$query = "SELECT COUNT(*) FROM atk_users WHERE login='$login'";
	$n = atk_dbgetfirst($query);
	return $n;
}

atk_dbconnect();

// Vrification de la validit des renseignements fournis
$atk_result = 1;
if(strlen($atk_passwd)<4) $atk_result=0;
if(strlen($atk_login)<2) $atk_result=0;
if(ereg("[[:space:][:punct:][:blank:]]", $atk_login)) $atk_result=0;
if($atk_result && atk_user_exist($login)) $atk_result=0;
if(empty($atk_email)) $atk_email="";
if(!empty($atk_email) && !(eregi("^[_\.0-9a-z-]+@([0-9a-z-]+\.)+[a-z]{2,4}$",$atk_email))) $atk_result=0;

if($atk_result){
	$DATE = time();
	// On enregistre le nouveau user dans la table users
	$atk_passwd = crypt($atk_passwd, $ATK_SALT);
	$query = "
		INSERT INTO atk_users
		(login, owner, passwd, email, subscribe, admin,signature,other)
		VALUES ('$atk_login', '$OWNER', '$atk_passwd', '$atk_email', '$DATE',1,'','')";
	$sql = atk_dbquery($query);
}

atk_dbclose();

return $atk_result;
?>